org.apache.lucene.search

## Class SortedNumericSortField

- java.lang.Object
- - org.apache.lucene.search.SortField
  - - org.apache.lucene.search.SortedNumericSortField

    public class SortedNumericSortField
    extends SortField

SortField for `SortedNumericDocValues`.

A SortedNumericDocValues contains multiple values for a field, so sorting with this technique "selects" a value as the representative sort value for the document.

By default, the minimum value in the list is selected as the sort value, but this can be customized.

Like sorting by string, this also supports sorting missing values as first or last, via `setMissingValue(Object)`.

See Also:
  `SortedNumericSelector`

### Nested Class Summary

### Nested classes/interfaces inherited from class org.apache.lucene.search.SortField

`SortField.Type`

### Field Summary

### Fields inherited from class org.apache.lucene.search.SortField

`FIELD_DOC, FIELD_SCORE, missingValue, STRING_FIRST, STRING_LAST`

### Constructor Summary

Constructors
Constructor and Description
`SortedNumericSortField(String field, SortField.Type type)` Creates a sort, by the minimum value in the set for the document.
`SortedNumericSortField(String field, SortField.Type type, boolean reverse)` Creates a sort, possibly in reverse, by the minimum value in the set for the document.
`SortedNumericSortField(String field, SortField.Type type, boolean reverse, SortedNumericSelector.Type selector)` Creates a sort, possibly in reverse, specifying how the sort value from the document's set is selected.

### Method Summary

All Methods Instance Methods Concrete Methods
`boolean` `equals(Object obj)` Returns true if `o` is equal to this.
`FieldComparator<?>` `getComparator(int numHits, int sortPos)` Returns the `FieldComparator` to use for sorting.
`SortField.Type` `getNumericType()` Returns the numeric type in use for this sort
`SortedNumericSelector.Type` `getSelector()` Returns the selector in use for this sort
`int` `hashCode()` Returns a hash code for this `SortField` instance.
`void` `setMissingValue(Object missingValue)` Set the value to use for documents that don't have a value.
`String` `toString()`

### Methods inherited from class org.apache.lucene.search.SortField

`getBytesComparator, getComparatorSource, getField, getMissingValue, getReverse, getType, needsScores, rewrite, setBytesComparator`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### SortedNumericSortField

    public SortedNumericSortField(String field,
                                  SortField.Type type)

Creates a sort, by the minimum value in the set for the document.

Parameters:
  `field` - Name of field to sort by. Must not be null.
  `type` - Type of values

#### SortedNumericSortField

    public SortedNumericSortField(String field,
                                  SortField.Type type,
                                  boolean reverse)

Creates a sort, possibly in reverse, by the minimum value in the set for the document.

Parameters:
  `field` - Name of field to sort by. Must not be null.
  `type` - Type of values
  `reverse` - True if natural order should be reversed.

#### SortedNumericSortField

    public SortedNumericSortField(String field,
                                  SortField.Type type,
                                  boolean reverse,
                                  SortedNumericSelector.Type selector)

Creates a sort, possibly in reverse, specifying how the sort value from the document's set is selected.

Parameters:
  `field` - Name of field to sort by. Must not be null.
  `type` - Type of values
  `reverse` - True if natural order should be reversed.
  `selector` - custom selector type for choosing the sort value from the set.

### Method Detail

#### getNumericType

    public SortField.Type getNumericType()

Returns the numeric type in use for this sort

#### getSelector

    public SortedNumericSelector.Type getSelector()

Returns the selector in use for this sort

#### hashCode

    public int hashCode()

Description copied from class: `SortField`
Returns a hash code for this `SortField` instance. If a `FieldComparatorSource` was provided, it must properly implement hashCode (unless a singleton is always used).

Overrides:
  `hashCode` in class `SortField`

#### equals

    public boolean equals(Object obj)

Description copied from class: `SortField`
Returns true if `o` is equal to this. If a `FieldComparatorSource` was provided, it must properly implement equals (unless a singleton is always used).

Overrides:
  `equals` in class `SortField`

#### toString

    public String toString()

Overrides:
  `toString` in class `SortField`

#### setMissingValue

    public void setMissingValue(Object missingValue)

Description copied from class: `SortField`
Set the value to use for documents that don't have a value.

Overrides:
  `setMissingValue` in class `SortField`

#### getComparator

    public FieldComparator<?> getComparator(int numHits,
                                            int sortPos)

Description copied from class: `SortField`
Returns the `FieldComparator` to use for sorting.

Overrides:
  `getComparator` in class `SortField`
Parameters:
  `numHits` - number of top hits the queue will store
  `sortPos` - position of this SortField within `Sort`. The comparator is primary if sortPos==0, secondary if sortPos==1, etc. Some comparators can optimize themselves when they are the primary sort.
Returns:
  `FieldComparator` to use when sorting